<?php 
/**
 * Contador de días (Resultado 2) - repaso_2b.php
 * 
 * @author    Bartolomé Sintes Marco <bartolome.sintes+mclibre@gmail.com>
 * @copyright 2011 Bartolomé Sintes Marco
 * @license   http://www.gnu.org/licenses/agpl.txt AGPL 3 or later
 * @version   2011-11-16
 * @link      http://www.mclibre.org
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Affero General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Affero General Public License for more details.
 *
 *  You should have received a copy of the GNU Affero General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
print "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?".">\n"; 
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
       "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
  <title>Contador de días (Resultado 2). Repaso 1. 
  Ejercicios. PHP. Bartolomé Sintes Marco</title>
  <link href="mclibre_php_soluciones.css" rel="stylesheet" type="text/css" 
  title="Color" />
</head>
<body>

<h1>Contador de días (Resultado 2)</h1>
<?php

function recoge($var) 
{
    $tmp = (isset($_REQUEST[$var])) ? strip_tags(trim(htmlspecialchars($_REQUEST[$var]))) : '';
    if (get_magic_quotes_gpc()) {
        $tmp = stripslashes($tmp);
    }
    return $tmp;
}

function recogeMatriz($var) 
{
    $tmpMatriz = array();
    if (isset($_REQUEST[$var]) && is_array($_REQUEST[$var])) {
        foreach ($_REQUEST[$var] as $indice => $valor) {
            $tmp = strip_tags(trim(htmlspecialchars($indice)));
            if (get_magic_quotes_gpc()) {
                $tmp = stripslashes($tmp);
            }
            $indiceLimpio = $tmp;

            $tmp = strip_tags(trim(htmlspecialchars($valor)));
            if (get_magic_quotes_gpc()) {
                $tmp = stripslashes($tmp);
            }
            $valorLimpio  = $tmp;

            $tmpMatriz[$indiceLimpio] = $valorLimpio;
        }
    }
    return $tmpMatriz;
}

define('NUM_MINIMO',    1);
define('NUM_MAXIMO',    20);
define('VALOR_CASILLA', 'on');

$numero           = recoge('numero');
$casillas         = recogeMatriz('c');
$numeroOk         = $casillasOk = FALSE;
$casillasMarcadas = count($casillas, COUNT_RECURSIVE)-count($casillas);

if ($numero=="") {
    print "<p class=\"aviso\">No se ha recibido el número de semanas.</p>\n";
} elseif (!is_numeric($numero)) { 
    print "<p class=\"aviso\">No se ha recibido el número de semanas "
         ."como número.</p>\n";
} elseif (!ctype_digit($numero)) { 
    print "<p class=\"aviso\">No se ha recibido el número de semanas "
         ."como número entero positivo.</p>\n";
} elseif (($numero<NUM_MINIMO)||($numero>NUM_MAXIMO)) {
    print "<p class=\"aviso\">El número de semanas debe estar entre "
         .NUM_MINIMO." y ".NUM_MAXIMO.".</p>\n";
} else {
    $numeroOk = TRUE;
}

if ($casillasMarcadas==0) {
    print "<p>No ha marcado ninguna casilla.</p>";
} elseif ($casillasMarcadas>$numero*7) {
    print "<p class=\"aviso\">La matriz recibida es demasiado grande.</p>\n";
} else {
    $casillasOk = TRUE;
    foreach ($casillas as $indice => $valor) {
        if (ctype_digit((string)$indice)&&($indice<=$numero)&&is_array($valor)) {
            foreach ($valor as $indice2 => $valor2) {
                if (!ctype_digit((string)$indice2)||($indice2>7)||($valor2!=VALOR_CASILLA)) {
                    $casillasOk = FALSE;
                }
            }
        } else {
            $casillasOk = FALSE; 
        }    	
    }
    if (!$casillasOk) {
        print "<p class=\"aviso\">La matriz recibida no es correcta.</p>\n";
    }
}    

if ($numeroOk && $casillasOk) {
    print "<p>En total ha marcado $casillasMarcadas días:</p>\n<ul>\n";
    for ($i=1; $i<=$numero; $i++) {
        if (!isset($casillas[$i])) {
            print "<li>En la semana $i no ha marcado ninguna día.</li>\n";
        } else {
            print "<li>En la semana $i ha marcado <strong>".
                count($casillas[$i])."</strong> día";
            if (count($casillas[$i])>1) {
                print "s";
            }
            print "</li>\n";
        }
    }
    print "</ul>\n<p><a href=\"repaso_2a.php?numero=$numero\">Volver al calendario</a></p>\n";
}

print "<p><a href=\"repaso_2.html\">Volver al formulario inicial.</a></p>\n";
?>

<address>
  Esta página forma parte del curso "Páginas web con PHP" disponible en <a
  href="http://www.mclibre.org/">http://www.mclibre.org</a><br />
  Autor: Bartolomé Sintes Marco<br />
  Última modificación de esta página: 16 de noviembre de 2011
</address>
<p class="licencia">El programa PHP que genera esta página está bajo 
<a rel="license" href="http://www.gnu.org/licenses/agpl.txt">licencia AGPL 3 o
posterior</a>.</p>
</body>
</html>
